     INC XML.DEF
PO   OBJECT
IN   CHAR 8000
C1   CHAR 40
C2   CHAR 40
C3   CHAR 40
SEQ FORM "-1"
FILE FILE VAR=8000, TEXT
     OPEN FILE, "XMLOUT"
     READ FILE, SEQ; IN                     . for example, read IN
     XMLMAKE PO                             . create empty PO
     XMLIMPORT PO, IN                       . import the XML data into PO
     XMLGETNAME PO, C1                      . the tag name of the top element
     GOTO ERROR IF (C1 != "PurchaseOrder")  . should be PurchaseOrder
     DISPLAY "Start of Purchase Order"
     LOOP                                   . loop through each sub-element
         XMLGETNEXT PO, C1, SETPOS          . C1 is name, set pos down 1 level
         BREAK IF OVER                      . no more sub-elements
         CONTINUE IF LESS                   . ignore any text at this level
         SWITCH C1
             CASE "OrderNumber"
                 XMLGETNEXT PO, C2          . assume the sub-element is text
                 DISPLAY "Order number: ", *LL, C2
             CASE "OrderDate"
                 DISPLAY "Order date: ";
                 XMLGETATTR PO, C2, C3      . get the attribute name and value
                 IF NOT OVER                . OVER means no attributes
                      DISPLAY "(", *LL, C2, "=#"", *LL, C3, "#") ";
                 ENDIF
                 XMLGETNEXT PO, C2          . assume the sub-element is text
                 DISPLAY *LL, C2
             CASE "Purchaser"
                 DISPLAY "Customer:"
                 CALL DISPLAYNAMEADDR       . print name and address
             CASE "Vendor"
                 DISPLAY "Vendor:"
                 CALL DISPLAYNAMEADDR       . print name and address
             CASE "Details"
                 CALL DETAILS
         ENDSWITCH                          . ignore any unknown sub-elements
         XMLSETPARENT PO                    . set position up 1 level
     REPEAT
     DISPLAY "End of Purchase Order"
     PAUSE "2"
     STOP
DISPLAYNAMEADDR
     LOOP
         XMLGETNEXT PO, C2, SETPOS          . C2 is name, set pos down 1 level
         RETURN IF OVER                     . no more sub-elements
         CONTINUE IF LESS                   . ignore any text at this level
         XMLGETNEXT PO, C3                  . C3 contains the text value
         CONTINUE IF NOT LESS               . should not occur (sub-element)
         DISPLAY "  ", *LL, C2, ": ", *LL, C3
         XMLSETPARENT PO                    . set position up 1 level
     REPEAT
DETAILS
     DISPLAY "<Details here>"               . NOT IMPLEMENTED
     RETURN
ERROR DISPLAY "ERROR!"
     PAUSE "2"
     STOP

