
xmlcode	class definition

xml		char @		. contains the XML data in normal stream format
keyword	char @		. keyword operand for getparm
var1	var @		. value operand for getparm
textop	char @		. xml... routine argument
nameop	char @		. xml... routine argument
attrop	char @		. xml... routine argument
valueop	char @		. xml... routine argument
posop	char @		. xml... routine argument
tagname char 32		. element name of the current node, always valid unless nodepos is 0
poslist	list		. list that contains the current position values
nodepos	int 5		. index in xml of '<' char of current node
endpos	int 5		. index in xml of '<' of end tag of current node, 0 if unknown, same as nodepos if no sub-elements
attrpos	int 5		. index in xml of first char of attr name of current node
subpos	int 5		. index in xml of first char of subelement - is '<' or otherwise
		listend		. end of list
pstack	queue		. LIFO stack holding poslist for parent/child operations
scanval char 500	. return value from scan... routines

.
xmlmake	routine
dflt	num "8000"
xmlsize	num @
	moveadr dflt to xmlsize
	clear scanval
	loop
		getparm keyword, var1
		break if over
		if (keyword = "")
			moveadr var1 to nameop
			move nameop to scanval
		else if (keyword = "MAXCHARSIZE")
			moveadr var1 to xmlsize
		endif
	repeat
	makevar ("C" + squeeze char xmlsize) to xml
	if (scanval != "")
		move scanval to tagname
		move ("<" + scanval + "/>") to xml
 		set nodepos
	endif
	return
	clear poslist
	endroutine

.
xmlfree	routine
	return
	endroutine

.
xmlimport routine textop
	clear poslist
	move textop to xml
	scan "<" in xml
	call setnodeinfo
	return
	endroutine

.
xmlexport routine textop
	reset xml
	move xml to textop
	return
	endroutine

.
xmlgetname routine nameop
	if (nodepos = 0)
		clear nameop
	else
	 	move tagname to nameop
	endif
	return
	endroutine

.
xmlgetattr routine attrop, valueop
	goto retover if (nodepos = 0)
	if (attrpos = 0)
		move nodepos to attrpos
		reset xml to (nodepos + 1)
		call scantag
	endif
	call scantag
	cmatch "=" to xml
	goto retover if not equal
	move scanval to attrop
	bump xml
	call scanliteral
	move scanval to valueop
	movefptr xml to attrpos
	return
	endroutine

.
xmlgetnext routine nameop
setposflag int 1
	clear setposflag
	goto retover if (nodepos = 0)
	getparm keyword, var1
	if not over
		if (keyword = "SETPOS")
			set setposflag
		endif
	endif
	call findendpos if (endpos = 0)
	goto retover if (nodepos = endpos)
	if (subpos = 0)
		call getfirstsubpos
	else
		call getnextsubpos if (subpos != endpos)
	endif
	goto retover if (subpos = endpos)
	reset xml to subpos
	cmatch "<" to xml
	if not equal
		call scantext
		move scanval to nameop 		
		setflag less
		return
	endif
	bump xml
	call scantag
	move scanval to nameop
	if (setposflag)
		putfirst pstack; poslist
		move subpos to nodepos
		clear attrpos, subpos, endpos
		move nameop to tagname
	endif
	setflag not less
	return
	endroutine

. add a node after the last sub-element of the current node
xmladdnode routine nameop
setposflag int 1
textflag int 1
	clear setposflag, textflag
	loop
		getparm keyword, var1
		break if over
		if (keyword = "SETPOS")
			set setposflag
		else if (keyword = "TEXT")
			moveadr var1 to textop
			set textflag
		endif
	repeat
	move "<" to scanval
	append nameop to scanval
	append "/>" to scanval
	reset scanval
	if (nodepos = 0)
		move scanval to xml
		set nodepos
	endif
	clear endpos
	call findendpos
	call splitnode if (nodepos = endpos)
	reset xml to endpos
	move "<" to scanval
	append nameop to scanval
	if (textflag)
		append ">" to scanval
		call scanvalappendtext with textop
		append "</" to scanval
		append nameop to scanval
		append ">" to scanval
	else
		append "/>" to scanval
	endif
	reset scanval
	call insertxml with endpos
	if (setposflag)
		putfirst pstack; poslist
		move endpos to nodepos
		clear attrpos
		move nameop to tagname
	endif
	clear subpos, endpos
	return
	endroutine

. add text after the current sub-element
xmladdtext routine textop
	return if (nodepos = 0)
	call findendpos if (endpos = 0)
	call splitnode if (nodepos = endpos)
	call getfirstsubpos if (subpos = 0)
	reset xml to subpos
	cmatch "<" to xml
	if equal
		call getnextsubpos if (endpos != subpos)
	else
		scan "<" in xml
		movefptr xml to subpos
	endif
	clear scanval
	call scanvalappendtext with textop
	reset scanval
	call insertxml with subpos
	return
	endroutine

. add an attribute after the attribute at the current position
xmladdattr routine attrop, valueop
	return if (nodepos = 0)
	if (attrpos = 0)
		move nodepos to attrpos
		reset xml to (nodepos + 1)
		call scantag
		movefptr xml to attrpos
	endif
	move " " to scanval
	append attrop to scanval
	append "=" to scanval
	append "#"" to scanval
	call scanvalappendtext with valueop
	append "#"" to scanval
	reset scanval
	call insertxml with attrpos
	return
	endroutine

. save the current position for later use by xmlsetpos
xmlgetpos routine posop
	unpack posop into poslist
	return
	endroutine

. set the current position to the position saved by xmlgetpos
xmlsetpos routine posop
	pack posop from poslist
	return
	endroutine

. set the current position to the parent
xmlsetparent routine
	get pstack; poslist
	call setnodeinfo
	clear endpos
	endroutine

. set the current position to the current subelement
xmlsetchild routine
	goto retover if (subpos = 0)
	reset xml to subpos
	cmatch "<" to xml
	goto retover if equal
	putfirst pstack; poslist
	move subpos to nodepos
	clear attrpos, subpos, endpos
	call setnodeinfo
	setflag not over
	return
	endroutine

. reset the attribute and subelement positions
xmlreset routine
	clear attrpos, subpos
	return
	endroutine

. return with over set
retover
	setflag over
	return

. find the endpos value for the current node
findendpos lroutine
	reset xml to nodepos
	call findendtag
	movefptr xml to endpos
	return
	endroutine

. find the matching end tag for the node at the current formpointer
findendtag lroutine
depth int 5
curfptr int 5
worktag char 32
	clear depth
findend1
	scan "<" in xml
	movefptr xml to curfptr
	bump xml
	cmatch "/" to xml
	if equal
		sub 1 from depth
		goto findend2 if zero
		call scantag
		scan ">" in xml
		bump xml
		goto findend1
	endif
	add 1 to depth
	call scantag
	bump xml by -1
	loop
		bump xml
		cmatch ">" to xml
		goto findend1 if equal
		cmatch "/" to xml
		if equal
			sub 1 from depth
			goto findend2 if zero
		endif 	
		cmatch "=" to xml
		call scanliteral if equal
 	repeat
findend2
	reset xml to curfptr
	return
	endroutine

. split the current node into start and end tag
splitnode lroutine
	reset xml to nodepos
	loop
		bump xml
		cmatch "/" to xml
		break if equal
		cmatch ">" to xml
		goto findendpos if equal
		cmatch "=" to xml
		call scanliteral if equal
	repeat
	cmove ">" to xml
	bump xml
	scan ">" in xml
	movefptr xml to endpos
	move ("</" + tagname) to scanval
	call insertxml with endpos
	return
	endroutine

. set subpos to the first sub-element of the current node
getfirstsubpos lroutine
	reset xml to nodepos
	goto getnextsubpos2
	endroutine

. set subpos to the next sub-element of the current node
getnextsubpos lroutine
	goto getfirstsubpos if (subpos = 0)
	reset xml to subpos
	cmatch "<" to xml
	goto getnextsubpos1 if equal
	scan "<" in xml
	movefptr xml to subpos
	setflag not over
	return
getnextsubpos1
	call findendtag
getnextsubpos2
	loop
		bump xml
		cmatch ">" to xml
		break if equal
		cmatch "=" to xml
		call scanliteral if equal
	repeat
	bump xml
	movefptr xml to subpos
	return
	endroutine

. insert scanval into xml at position specified
insertxml lroutine pos
pos num @
n1 int 5
n2 int 5
n3 int 5
c1 init " "
	movelptr scanval to n1
	move (lengthptr xml + n1) to n2, n3
	reset xml to n2
	loop
		sub n1 from n2
		reset xml to n2
		break if (pos > n2)
		cmove xml to c1
		add n1 to n2
		reset xml to n2
		cmove c1 to xml
		sub 1 from n2
	repeat
	append scanval to xml
	reset xml to n3
	return
	endroutine

. scan the node name
setnodeinfo lroutine
	if (nodepos = 0)
		reset xml
	else
		reset xml to nodepos
	endif
	scan "<" in xml
	return if not equal
	movefptr xml to nodepos
	bump xml
	call scantag
	move scanval to tagname
	return
	endroutine

. scan a token and return it in scanval, skip whitespace before token
scantag lroutine
tagchars init "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-:"
c1 init " "
	clear scanval
	cmatch " " to xml
	return if eos
	if equal
		bump xml
		return if eos
	endif
	loop
		cmove xml to c1
		reset tagchars
		scan c1 in tagchars
		break if not equal
		append c1 to scanval
		bump xml
		return if eos
	repeat
scanreturn
	cmatch " " to scanval
	return if eos
	reset scanval
	return
	endroutine

. scan a literal
scanliteral lroutine
	clear scanval
	cmatch " " to xml
	if equal
		bump xml
		return if eos
		goto scanliteral
	endif
	cmatch """ to xml
	return if not equal
	bump xml
	return if eos
scanliteral1
	cmatch """ to xml
	goto scanreturn if equal
	call scangetchar
	bump xml
	goto scanliteral1 if not eos
	goto scanreturn
	endroutine

. scan text
scantext lroutine
	clear scanval
scantext1
	cmatch "<" to xml
	goto scanreturn if equal
	call scangetchar
	bump xml
	goto scantext1 if not eos
	goto scanreturn
	endroutine

. append text to scanval, replace special chars with & sequences
scanvalappendtext lroutine sourcep
sourcep char @
source char 500
c1 init " "
	move sourcep to source
scapptxt1
	cmatch "<" to source
	goto scapptxt3 if equal
	cmatch ">" to source
	goto scapptxt4 if equal
	cmatch """ to source
	goto scapptxt5 if equal
	cmatch "&" to source
	goto scapptxt6 if equal
	cmove source to c1
	append c1 to scanval
scapptxt2
	bump source
	return if eos
	goto scapptxt1
scapptxt3
	append "&lt;" to scanval
	goto scapptxt2
scapptxt4
	move "&gt;" to scanval
	goto scapptxt2
scapptxt5
	move "&quot;" to scanval
	goto scapptxt2
scapptxt6
	move "&amp;" to scanval
	goto scapptxt2
	endroutine

. work routine for scan routines
scangetchar lroutine
c1 init " "
	cmatch "&" to xml
	goto scanget1 if equal
	cmove xml to c1
scangetreturn
	append c1 to scanval
	return
scanget1
	match "&gt;" to xml
	goto scanget2 if not equal
	goto scanget2 if not less
	bump xml by 3
	cmove ">" to c1
	goto scangetreturn
scanget2
	match "&lt;" to xml
	goto scanget3 if not equal
	goto scanget3 if not less
	bump xml by 3
	cmove "<" to c1
	goto scangetreturn
scanget3
	match "&quot;" to xml
	goto scanget4 if not equal
	goto scanget4 if not less
	bump xml by 5
	cmove """ to c1
	goto scangetreturn
scanget4
	match "&amp;" to xml
	goto scanget5 if not equal
	goto scanget5 if not less
	bump xml by 4
	cmove "&" to c1
	goto scangetreturn
scanget5
	bump xml
	cmove "?" to c1
	goto scangetreturn
	endroutine

	endclass
